/***************************************************************************
                          dualvariable.cpp  -  description
                             -------------------
    begin                : Tue Aug 1 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dualvariable.h"

CDualVariable::CDualVariable()
{
}
CDualVariable::~CDualVariable()
{
}
/**  */
const string& CDualVariable::GlobalIdentifier() const
{
	return m_GlobalIdentifier;
}
/**  */
void CDualVariable::SetGlobalIdentifier(const string& Identifier)
{
  m_GlobalIdentifier = Identifier;
}
/**  */
void CDualVariable::GenerateGlobalReading(ostream& Stream,
  void* pExtraParameter = NULL) const
{
	Stream << "  " << Identifier() << " = " << GlobalIdentifier() << ";" << endl;
}
/**  */
void CDualVariable::GenerateGlobalWriting(ostream& Stream,
  void* pExtraParameter = NULL) const
{
	Stream << "  " << GlobalIdentifier() << " = " << Identifier() << ";" << endl;
}
/**  */
void CDualVariable::GenerateGlobalDeclarations(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	Stream << Type() << " " << GlobalIdentifier() << ";" << endl;
}
/**  */
bool CDualVariable::DescendantOf(const string& ClassName) const
{
	if (ClassName == "CDualVariable")
		return true;
	else
		return CVariable::DescendantOf(ClassName);
}
