/***************************************************************************
                          dualvariable.h  -  description
                             -------------------
    begin                : Tue Aug 1 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DUALVARIABLE_H
#define DUALVARIABLE_H

#include "variable.h"

/**
  *@author Ivan Martinez
  */

class CDualVariable : public CVariable  {
public: 
	CDualVariable();
	~CDualVariable();
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& GlobalIdentifier() const;
protected: // Protected methods
  /**  */
  virtual void GenerateGlobalDeclarations(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalReading(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalWriting(ostream&, void* = NULL) const;
  /**  */
  void SetGlobalIdentifier(const string&);
private: // Private attributes
  /**  */
  string m_GlobalIdentifier;
};

#endif
