/***************************************************************************
                          inputvariable.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "input.h"

#include "block.h"
#include "loop.h"

CInput::CInput()
{
	m_pConnectedOutput = NULL;
}
CInput::~CInput()
{
}
/**  */
const COutput* CInput::ConnectedOutput() const
{
	return m_pConnectedOutput;
}
/**  */
bool CInput::Connect(COutput* pOutput)
{
	m_pConnectedOutput = pOutput;

	return true;
}
/**  */
bool CInput::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CInput")
		return true;
	else
		return CInitializableVariable::DescendantOf(ClassNameL);
}
/**  */
void CInput::Arrange(void* ExtraParameterL = NULL)
{
	if (IllegalCIdentifier(Identifier()))
		AddError(600);
	else
		if (Connected())
			SetGlobalIdentifier("iovar_" + Container()->Container()->Identifier() + "_" +
				ConnectedOutput()->Container()->Name() + "_" +
				ConnectedOutput()->Identifier());
		else
			AddError(1400);
}
/**  */
const CBlock* CInput::Container() const
{
	return (CBlock*)CInitializableVariable::Container();
}
/**  */
bool CInput::Connected() const
{
	return (ConnectedOutput() != NULL);
}
/**  */
bool CInput::ConnectedToOrderedBlock(const CCodeGeneratorPointers& OrderedComponents) const
{
	if (Connected())
		return OrderedComponents.Contains(ConnectedOutput()->Container());
	else
		return false;
}
/**  */
bool CInput::SetInitialization(const string& Initialization)
{
	CInitializableVariable::SetInitialization(Initialization);

	return true;
}
