/***************************************************************************
                          variable.cpp  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "variable.h"

CVariable::CVariable()
{
	TypeA = "";
}
CVariable::~CVariable()
{
}
/**  */
const string& CVariable::Type() const
{
	return TypeA;
}
/**  */
void CVariable::SetType(const string& Type)
{
	TypeA = Type;
}
/**  */
bool CVariable::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CVariable")
		return true;
	else
		return CCodeGenerator::DescendantOf(ClassNameL);
}
/**  */
void CVariable::GenerateLocalDeclarations(ostream& StreamL,
	void* ExtraParameterL = NULL) const
{
	StreamL	<< "  static " << Type() << " " << Identifier() << ";" << endl;
}
/**  */
void CVariable::ComponentsDependingArrange(void* ExtraParameterL = NULL)
{
	if (Container()->RepeatedValue(this, "name", Identifier()))
		AddError(601);
}
/**  */
bool CVariable::RepeatedValue(const CCodeGenerator* CallerPL, const string& ValueNameL,
	const string& ValueL) const
{
	if ((CallerPL != this) && (ValueNameL == "name") &&
			(ValueL == Identifier()))
		return true;
	else
		return Components().RepeatedValue(CallerPL, ValueNameL, ValueL);
}
